%define snapshot 1
%define version	2.5.9.27115

%define majorver %(echo %{version} | cut -d. -f1-3)

%define pkgname Firebird-%{version}-0

%define somajor 2.5
%define libfbembed %mklibname fbembed %somajor
%define libfbembed_devel %mklibname fbembed -d

Summary:	Firebird2 embed SQL database management system
Name:		fbembed
Version:	%{version}
Release:	%mkrel 8
Group:		Databases
License:	MPLv1.1-like
URL:		http://www.firebirdsql.org/
%if 0%{?snapshot:1}
Source0:	http://web.firebirdsql.org/download/snapshot_builds/linux/fb2.5/%{pkgname}.tar.bz2
%else
Source0:	http://downloads.sourceforge.net/firebird/%{pkgname}.tar.bz2
%endif
Source1:	fbembed_config

# from upstream
Patch0:         firebird-btyacc-fpie.patch

# from openSUSE
Patch10:        allow-creating-buildRoot-as-non-root-user.patch
Patch11:        add-pkgconfig-files.patch

BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	libtool
BuildRequires:  pkgconfig(ncurses)
BuildRequires:  libtermcap-devel
BuildRequires:  icu-devel
BuildRequires:  pkgconfig(libedit)
BuildRequires:	gcc-c++
BuildRequires:	libstdc++-static-devel
BuildRequires:	pkgconfig(atomic_ops)
BuildRequires:  sed

%description
This is the Firebird2 embed SQL Database shared files.


%package -n %libfbembed_devel
Summary:	Development Libraries for Firebird2 SQL Database
Group:		Development/Databases
Requires:	%libfbembed = %{version}-%{release}

%description -n %libfbembed_devel
This package contains the headers that programmers will need to develop
applications which will use fbembed.


%package -n %libfbembed
Summary:	Multi-process, local client libraries for Firebird2 SQL Database
Group:		System/Libraries
Obsoletes:	%{_lib}fbembed2 < 2.5.8

%description -n %libfbembed
Multi-process, local client libraries for Firebird2 SQL Database


%prep
%setup -q -n %{pkgname}
%patch0 -p0
%patch10 -p1
%patch11 -p1

# fix build with glibc >= 2.28
sed -i -e '/libio.h/d' src/jrd/perf.h

# fix build on aarch64
for d in ./extern/editline/ ./extern/icu/source/ ./builds/make.new/config/; do
  cp -af %{_rpmconfigdir}/%{_real_vendor}/config.{guess,sub} $d
done

%build
# disable -Wl,--no-undefined to avoid fail build of fbintl
# when fbintl is loaded, one of the modules (libfbembed or fbserver) for sure exports
# gds__log()
%define _disable_ld_no_undefined 1

# fix build with CXXFLAGS from Gentoo bug report
# https://bugs.gentoo.org/639614#c6
export CXXFLAGS="%{optflags} -std=gnu++98 -flifetime-dse=1 -fno-sized-deallocation -fno-delete-null-pointer-checks"
NOCONFIGURE=1 ./autogen.sh
%configure --prefix=%{_prefix} \
  --disable-static \
  --with-system-icu \
  --with-system-editline \
  --with-fbbin=%{_bindir} --with-fbsbin=%{_sbindir} \
  --with-fbconf=%{_sysconfdir}/%{name} \
  --with-fblib=%{_libdir} --with-fbinclude=%{_includedir}/%{name} \
  --with-fbdoc=%{_docdir}/%{name} \
  --with-fbudf=%{_libdir}/%{name}/udf \
  --with-fbsample=%{_docdir}/%{name}/sample \
  --with-fbsample-db=%{_libdir}/%{name}/sample \
  --with-fbhelp=%{_libdir}/%{name}/lib \
  --with-fbintl=%{_libdir}/%{name}/intl \
  --with-fbmisc=%{_datadir}/%{name}/misc \
  --with-fbsecure-db=%{_localstatedir}/lib/%{name}/secdb \
  --with-fbmsg=%{_libdir}/%{name}/lib \
  --with-fblog=%{_localstatedir}/log/%{name} \
  --with-fbglock=%{_localstatedir}/run/%{name} \
  --with-fbplugins=%{_libdir}/%{name}/plugins

make
cd gen
make -f Makefile.install buildRoot
chmod -R u+w buildroot%{_docdir}/%{name}

%install
mkdir -p %{buildroot}%{_libdir}/pkgconfig
cp -v gen/install/misc/*.pc %{buildroot}%{_libdir}/pkgconfig/

cp -v gen/buildroot%{_sbindir}/fb_config %{buildroot}%{_libdir}/%{name}_config
sed -i '/plugins/d' %{buildroot}%{_libdir}/%{name}_config

mkdir -p %{buildroot}%{_includedir}/%{name}
cp -a gen/buildroot%{_includedir}/%{name}/* %{buildroot}%{_includedir}/%{name}/
rm -vf %{buildroot}%{_includedir}/%{name}/perf.h
rm -vf %{buildroot}%{_includedir}/%{name}/ib_util.h

mkdir -p %{buildroot}%{_libdir}
cp -a gen/buildroot%{_libdir}/libfbembed.so* %{buildroot}%{_libdir}/

mkdir -p %{buildroot}%{_bindir}
install -p -m 0755 %{SOURCE1} %{buildroot}%{_bindir}/fb_config

%files -n %libfbembed
%{_libdir}/libfbembed.so.%{somajor}
%{_libdir}/libfbembed.so.%{majorver}

%files -n %libfbembed_devel
%{_includedir}/%{name}/
%{_libdir}/libfbembed.so
%{_libdir}/%{name}_config
%{_bindir}/fb_config
%{_libdir}/pkgconfig/fbembed.pc


%changelog
* Mon Nov 30 2020 luigiwalser <luigiwalser> 2.5.9.27115-8.mga8
+ Revision: 1650883
- rebuild for icu

* Wed Jul 01 2020 wally <wally> 2.5.9.27115-7.mga8
+ Revision: 1601020
- rebuild for icu 67.1

* Sat Apr 04 2020 wally <wally> 2.5.9.27115-6.mga8
+ Revision: 1564456
- rebuild for new icu 66.1

* Sun Feb 16 2020 umeabot <umeabot> 2.5.9.27115-5.mga8
+ Revision: 1534584
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sat Oct 05 2019 daviddavid <daviddavid> 2.5.9.27115-4.mga8
+ Revision: 1449442
- rebuild for new icu 65.1

* Fri Jan 11 2019 daviddavid <daviddavid> 2.5.9.27115-3.mga7
+ Revision: 1354696
- rebuild for new icu

* Sun Sep 09 2018 wally <wally> 2.5.9.27115-2.mga7
+ Revision: 1258100
- fix build on arm and aarch64

* Sun Sep 09 2018 wally <wally> 2.5.9.27115-1.mga7
+ Revision: 1258070
- new snapshot version 2.5.9.27115
+ daviddavid <daviddavid>
- rebuild for new icu

* Wed Jun 06 2018 wally <wally> 2.5.8.27089-2.mga7
+ Revision: 1235014
- fix build on aarch64

* Sat Jan 06 2018 wally <wally> 2.5.8.27089-1.mga7
+ Revision: 1190794
- new snapshot version 2.5.8.27089
- fix lib pkg name
- drop upstreamed patches
- rebuild for new icu

* Wed Mar 15 2017 mrambo3501 <mrambo3501> 2.5.5.26952-7.mga6
+ Revision: 1092689
- Rebuild for icu-58.2

* Sat May 14 2016 shlomif <shlomif> 2.5.5.26952-6.mga6
+ Revision: 1015269
- Rebuild for the new UCI (new major)

* Sun Apr 10 2016 philippem <philippem> 2.5.5.26952-5.mga6
+ Revision: 1000009
- wrong name in fbembed_config

* Sun Apr 10 2016 philippem <philippem> 2.5.5.26952-4.mga6
+ Revision: 999964
- imported package fbembed

